- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::SymTMatrix Class Reference

Class for symmetric matrices stored in triplet format. More...

`#include <IpSymTMatrix.hpp>`

Inheritance diagram for Ipopt::SymTMatrix:

[legend]
Collaboration diagram for Ipopt::SymTMatrix:

[legend]
List of all members.

## Public Member Functions
Constructors / Destructors
| SymTMatrix (const SymTMatrixSpace *owner_space)
| Constructor, taking the corresponding matrix space.
| ~SymTMatrix ()
| Destructor.
Changing the Values.
void | SetValues (const Number *Values)
| Set values of nonzero elements.
Accessor Methods
Index | Nonzeros () const
| Number of nonzero entries.
const Index * | Irows () const
| Obtain pointer to the internal Index array irn_ without the intention to change the matrix data (USE WITH CARE!).
const Index * | Jcols () const
| Obtain pointer to the internal Index array jcn_ without the intention to change the matrix data (USE WITH CARE!).
Number * | Values ()
| Obtain pointer to the internal Number array values_ with the intention to change the matrix data (USE WITH CARE!).
const Number * | Values () const
| Obtain pointer to the internal Number array values_ without the intention to change the matrix data (USE WITH CARE!).
Methods for providing copy of the matrix data
void | FillStruct (ipfint *Irn, ipfint *Jcn) const
| Copy the nonzero structure into provided space.
void | FillValues (Number *Values) const
| Copy the value data into provided space.
## Protected Member Functions
Methods overloaded from matrix
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply.
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan).
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix.
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| SymTMatrix ()
| Default Constructor.
| SymTMatrix (const SymTMatrix &)
| Copy Constructor.
void | operator= (const SymTMatrix &)
| Overloaded Equals Operator.
## Private Attributes
const SymTMatrixSpace * | owner_space_
| Copy of the owner_space ptr as a SymTMatrixSpace insteaqd of a MatrixSpace.
Number * | values_
| Values of nonzeros.
bool | initialized_
| Flag for Initialization.

## Detailed Description

Class for symmetric matrices stored in triplet format.

In the triplet format, the nonzeros elements of a symmetric matrix is stored in three arrays, Irn, Jcn, and Values, all of length Nonzeros. The first two arrays indicate the location of a non-zero element (as the row and column indices), and the last array stores the value at that location. Off-diagonal elements need to be stored only once since the matrix is symmetric. For example, the element would be stored only once, either with Irn[i]=1 and Jcn[i]=2, or with Irn[i]=2 and Jcn[i]=1. Both representations are identical. If nonzero elements (or their symmetric counter part) are listed more than once, their values are added.

The structure of the nonzeros (i.e. the arrays Irn and Jcn) cannot be changed after the matrix can been initialized. Only the values of the nonzero elements can be modified.

Note that the first row and column of a matrix has index 1, not 0.

Definition at line 42 of file IpSymTMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::SymTMatrix::SymTMatrix | ( | const SymTMatrixSpace * | owner_space | ) |

Constructor, taking the corresponding matrix space.

Ipopt::SymTMatrix::~SymTMatrix | ( |  | ) |

Destructor.

Ipopt::SymTMatrix::SymTMatrix | ( |  | ) | `[private]`

Default Constructor.

Ipopt::SymTMatrix::SymTMatrix | ( | const SymTMatrix & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

void Ipopt::SymTMatrix::SetValues | ( | const Number * | Values | ) |

Set values of nonzero elements.

The values of the nonzero elements is copied from the incoming Number array. Important: It is assume that the order of the values in Values corresponds to the one of Irn and Jcn given to the matrix space.

Index Ipopt::SymTMatrix::Nonzeros | ( |  | ) | const`[inline]`

Number of nonzero entries.

Definition at line 234 of file IpSymTMatrix.hpp.

References Ipopt::SymTMatrixSpace::Nonzeros(), and owner_space_.

const Index * Ipopt::SymTMatrix::Irows | ( |  | ) | const`[inline]`

Obtain pointer to the internal Index array irn_ without the intention to change the matrix data (USE WITH CARE!).

This does not produce a copy, and lifetime is not guaranteed!

Definition at line 240 of file IpSymTMatrix.hpp.

References Ipopt::SymTMatrixSpace::Irows(), and owner_space_.

const Index * Ipopt::SymTMatrix::Jcols | ( |  | ) | const`[inline]`

Obtain pointer to the internal Index array jcn_ without the intention to change the matrix data (USE WITH CARE!).

This does not produce a copy, and lifetime is not guaranteed!

Definition at line 246 of file IpSymTMatrix.hpp.

References Ipopt::SymTMatrixSpace::Jcols(), and owner_space_.

Number* Ipopt::SymTMatrix::Values | ( |  | ) |

Obtain pointer to the internal Number array values_ with the intention to change the matrix data (USE WITH CARE!).

This does not produce a copy, and lifetime is not guaranteed!

const Number* Ipopt::SymTMatrix::Values | ( |  | ) | const

Obtain pointer to the internal Number array values_ without the intention to change the matrix data (USE WITH CARE!).

This does not produce a copy, and lifetime is not guaranteed!

void Ipopt::SymTMatrix::FillStruct | ( | ipfint * | Irn,
|  | ipfint * | Jcn |
| ) |  |  | const

Copy the nonzero structure into provided space.

void Ipopt::SymTMatrix::FillValues | ( | Number * | Values | ) | const

Copy the value data into provided space.

virtual void Ipopt::SymTMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, virtual]`

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::SymTMatrix::HasValidNumbersImpl | ( |  | ) | const`[protected, virtual]`

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::SymTMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init |
| ) |  |  | const`[protected, virtual]`

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::SymTMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix |
| ) |  |  | const`[protected, virtual]`

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::SymTMatrix::operator= | ( | const SymTMatrix & |  | ) | `[private]`

Overloaded Equals Operator.

## Member Data Documentation

const SymTMatrixSpace* Ipopt::SymTMatrix::owner_space_`[private]`

Copy of the owner_space ptr as a SymTMatrixSpace insteaqd of a MatrixSpace.

Reimplemented from Ipopt::SymMatrix.

Definition at line 147 of file IpSymTMatrix.hpp.

Referenced by Irows(), Jcols(), and Nonzeros().

Number* Ipopt::SymTMatrix::values_`[private]`

Values of nonzeros.

Definition at line 150 of file IpSymTMatrix.hpp.

bool Ipopt::SymTMatrix::initialized_`[private]`

Flag for Initialization.

Definition at line 153 of file IpSymTMatrix.hpp.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.7.1/Ipopt/src/LinAlg/TMatrices/IpSymTMatrix.hpp